% QUANTILE REGRESSION TO CALCULATE VaR
% display the varaibles: tbpsg_vars(problem_statement,toolboxstruc_arr) 
% solve the problem: [solution_str,outargstruc_arr]=tbpsg_run(problem_statement,toolboxstruc_arr)
% get the optimal point data: output = tbpsg_optimal_point_data(solution_str, outargstruc_arr)
% get the optimal point vars: output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr)
% original data are sorted by the banks: BBT, STT, PNC, COF, USB, BK, WFC,
% C,JPM,BAC

clc
clear

load data_Quantile_regression.mat original_matrix original_benchmark

vars={'intercept','vix','ls','tc','tsc','csc','er','reer'}; %define the variables, including intercept

alpha=0.9;

for i=1:10 % n denotes the number of bank
    disp('  ')
    % Prepare data for subroutine
    matrix=original_matrix; %Bank i's data_matrix
    benchmark=original_benchmark(:,i); % Bank i's benchmark vector
 
    % Run subroutine to minimize KB error
    disp(sprintf('Problem # %g',i))
    [solution_str,outargstruc_arr] = minimize_KB_err(matrix,vars,benchmark,alpha);
    disp(' ')
    
    % Extract from the solution report optimal point data and vars
    solution_result(i,:) = tbpsg_optimal_point_data(solution_str, outargstruc_arr); % store the optimal variables of different banks
    solution_varialbe(i,:) = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);%store the variables name of the solution
    
    % Extract from the solution report pseudo R square
    names = tbpsg_function_names(solution_str, outargstruc_arr);
    val = tbpsg_function_data(solution_str, outargstruc_arr); % get the objective value, Pseduo R square and adjusted Pseduo R square
    Pseduo_R_square(i) = val(find(strcmp(names,'adjusted_pseudo_r2_kb_err(0.9,matrix_style_qr)')));
    
    clear val matrix benchmark solution_str outargstruc_arr output
end

% Sort optimal point data to the initial order
pos = [];
for i=1:size(vars,2)
   pos = [pos, find(strcmp(solution_varialbe(1,:),vars{i}))];
end
output_result = solution_result(:,pos);

% Resulted data
var_bank = original_matrix*output_result';

%xlswrite('H:\cocvar data\var_bank_0.5',var_bank);



