%This M-Function was created automatically by PSG Toolbox. 
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" 
%in PSG Help Manual   
%
%Input variables:
%
%Inputs           PSG Type    PSG Object         Location in Problem Statement              Class
%matrix           data        matrix_style_qr    kb_err(parameter_alpha,matrix_style_qr)    double
%vars             vars        matrix_style_qr    kb_err(parameter_alpha,matrix_style_qr)    cell
%benchmark        bench       matrix_style_qr    kb_err(parameter_alpha,matrix_style_qr)    double
%alpha            data        parameter_alpha    kb_err(parameter_alpha,matrix_style_qr)    double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = minimize_KB_err(matrix,vars,benchmark,alpha)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_style_qr',matrix,vars,benchmark,[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'kb_err(parameter_alpha,matrix_style_qr)',...
' ');
%Change parameters with their values in problem statement:
problem_statement=strrep(problem_statement,'parameter_alpha',num2str(alpha));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);

results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

